diff --git a/plugins/blur.c b/plugins/blur.c
index d7da5da..ecb3a6d 100644
--- a/plugins/blur.c
+++ b/plugins/blur.c
@@ -588,7 +588,7 @@ blurSetScreenOption (CompPlugin      *plugin,
 	{
 	    CompWindow *w;
 
-	    for (w = screen->windows; w; w = w->next)
+	    for (w = screen->root.windows; w; w = w->next)
 		blurUpdateWindowMatch (bs, w);
 
 	    bs->moreBlur = TRUE;
@@ -784,7 +784,7 @@ blurPreparePaintScreen (CompScreen *s,
 
 	bs->moreBlur = FALSE;
 
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	{
 	    BLUR_WINDOW (w);
 
@@ -843,7 +843,7 @@ blurPreparePaintScreen (CompScreen *s,
 	    int	       x1, y1, x2, y2;
 	    int	       count = 0;
 
-	    for (w = s->windows; w; w = w->next)
+	    for (w = s->root.windows; w; w = w->next)
 	    {
 		BLUR_WINDOW (w);
 
@@ -914,7 +914,7 @@ blurPaintOutput (CompScreen		 *s,
 
 	XSubtractRegion (&emptyRegion, &emptyRegion, bs->occlusion);
 
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	    XSubtractRegion (&emptyRegion, &emptyRegion,
 			     GET_BLUR_WINDOW (w, bs)->clip);
     }
@@ -944,7 +944,7 @@ blurPaintTransformedOutput (CompScreen		    *s,
 
 	XSubtractRegion (&emptyRegion, &emptyRegion, bs->occlusion);
 
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	    XSubtractRegion (&emptyRegion, &emptyRegion,
 			     GET_BLUR_WINDOW (w, bs)->clip);
     }
@@ -964,7 +964,7 @@ blurDonePaintScreen (CompScreen *s)
     {
 	CompWindow *w;
 
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	{
 	    BLUR_WINDOW (w);
 
@@ -2715,7 +2715,7 @@ blurMatchExpHandlerChanged (CompDisplay *d)
     {
 	BLUR_SCREEN (s);
 
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	    blurUpdateWindowMatch (bs, w);
     }
 }
@@ -2735,10 +2735,10 @@ blurMatchPropertyChanged (CompDisplay *d,
 }
 
 static void
-blurWindowAdd (CompScreen *s,
+blurWindowAdd (CompObject *parent,
 	       CompWindow *w)
 {
-    BLUR_SCREEN (s);
+    BLUR_SCREEN (w->screen);
 
     blurWindowUpdate (w, BLUR_STATE_CLIENT);
     blurWindowUpdate (w, BLUR_STATE_DECOR);
@@ -2772,7 +2772,8 @@ blurInitCore (CompPlugin *p,
 {
     BlurCore *bc;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     bc = malloc (sizeof (BlurCore));
@@ -3112,7 +3113,7 @@ blurInitWindow (CompPlugin *p,
     w->base.privates[bs->windowPrivateIndex].ptr = bw;
 
     if (w->base.parent)
-	blurWindowAdd (w->screen, w);
+	blurWindowAdd (w->base.parent, w);
 
     return TRUE;
 }
diff --git a/plugins/clone.c b/plugins/clone.c
index 31b78a6..4854406 100644
--- a/plugins/clone.c
+++ b/plugins/clone.c
@@ -167,7 +167,7 @@ cloneFinish (CompScreen *s)
 
 		    clone->input =
 			XCreateWindow (s->display->display,
-				       s->root, x, y,
+				       s->root.id, x, y,
 				       s->outputDev[cs->dst].width,
 				       s->outputDev[cs->dst].height,
 				       0, 0, InputOnly, CopyFromParent,
@@ -400,7 +400,7 @@ clonePaintOutput (CompScreen		  *s,
 	if (cs->offset == 0.0f)
 	    s->display->textureFilter = GL_LINEAR_MIPMAP_LINEAR;
 
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	{
 	    if (w->destroyed)
 		continue;
@@ -515,7 +515,7 @@ cloneTerminate (CompDisplay     *d,
     {
 	CLONE_SCREEN (s);
 
-	if (xid && s->root != xid)
+	if (xid && s->root.id != xid)
 	    continue;
 
 	if (cs->grabIndex)
@@ -723,7 +723,8 @@ cloneInitDisplay (CompPlugin  *p,
 {
     CloneDisplay *cd;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     cd = malloc (sizeof (CloneDisplay));
diff --git a/plugins/cube.c b/plugins/cube.c
index 91845f8..eaf76ed 100644
--- a/plugins/cube.c
+++ b/plugins/cube.c
@@ -1277,59 +1277,6 @@ cubePaintInside (CompScreen		 *s,
 }
 
 static void
-cubeEnableOutputClipping (CompScreen 	      *s,
-			  const CompTransform *transform,
-			  Region	      region,
-			  CompOutput 	      *output)
-{
-    CUBE_SCREEN (s);
-
-    if (cs->rotationState != RotationNone)
-    {
-	glPushMatrix ();
-	glLoadMatrixf (transform->m);
-	glTranslatef (cs->outputXOffset, -cs->outputYOffset, 0.0f);
-	glScalef (cs->outputXScale, cs->outputYScale, 1.0f);
-
-	if (cs->invert == 1)
-	{
-	    GLdouble clipPlane0[] = {  1.0, 0.0, 0.5 / cs->distance, 0.0 };
-	    GLdouble clipPlane1[] = {  -1.0,  0.0, 0.5 / cs->distance, 0.0 };
-	    GLdouble clipPlane2[] = {  0.0,  -1.0, 0.5 / cs->distance, 0.0 };
-	    GLdouble clipPlane3[] = { 0.0,  1.0, 0.5 / cs->distance, 0.0 };
-	    glClipPlane (GL_CLIP_PLANE0, clipPlane0);
-	    glClipPlane (GL_CLIP_PLANE1, clipPlane1);
-	    glClipPlane (GL_CLIP_PLANE2, clipPlane2);
-	    glClipPlane (GL_CLIP_PLANE3, clipPlane3);
-	}
-	else
-	{
-	    GLdouble clipPlane0[] = {  -1.0, 0.0, -0.5 / cs->distance, 0.0 };
-	    GLdouble clipPlane1[] = {  1.0,  0.0, -0.5 / cs->distance, 0.0 };
-	    GLdouble clipPlane2[] = {  0.0,  1.0, -0.5 / cs->distance, 0.0 };
-	    GLdouble clipPlane3[] = { 0.0,  -1.0, -0.5 / cs->distance, 0.0 };
-	    glClipPlane (GL_CLIP_PLANE0, clipPlane0);
-	    glClipPlane (GL_CLIP_PLANE1, clipPlane1);
-	    glClipPlane (GL_CLIP_PLANE2, clipPlane2);
-	    glClipPlane (GL_CLIP_PLANE3, clipPlane3);
-	}
-
-	glEnable (GL_CLIP_PLANE0);
-	glEnable (GL_CLIP_PLANE1);
-	glEnable (GL_CLIP_PLANE2);
-	glEnable (GL_CLIP_PLANE3);
-
-	glPopMatrix ();
-    }
-    else
-    {
-	UNWRAP (cs, s, enableOutputClipping);
-	(*s->enableOutputClipping) (s, transform, region, output);
-	WRAP (cs, s, enableOutputClipping, cubeEnableOutputClipping);
-    }
-}
-
-static void
 cubePaintViewport (CompScreen              *s,
 		   const ScreenPaintAttrib *sAttrib,
 		   const CompTransform     *transform,
@@ -1580,7 +1527,8 @@ cubePaintWindow (CompWindow		  *w,
     CompScreen *s = w->screen;
     CUBE_SCREEN (s);
 
-    if ((w->type & CompWindowTypeDesktopMask) &&
+    if (w->parent == &s->root &&
+	(w->type & CompWindowTypeDesktopMask) &&
 	(attrib->opacity != cs->desktopOpacity))
     {
 	WindowPaintAttrib wAttrib = *attrib;
@@ -1602,12 +1550,12 @@ cubePaintWindow (CompWindow		  *w,
 }
 
 static void
-cubeInitWindowWalker (CompScreen *s, CompWalker* walker)
+cubeInitWindowWalker (CompScreen *s, CompWindow *w, CompWalker* walker)
 {
     CUBE_SCREEN (s);
 
     UNWRAP (cs, s, initWindowWalker);
-    (*s->initWindowWalker) (s, walker);
+    (*s->initWindowWalker) (s, w, walker);
     WRAP (cs, s, initWindowWalker, cubeInitWindowWalker);
 
     if (cs->paintOrder == FTB)
@@ -1701,7 +1649,7 @@ cubeFold (CompDisplay     *d,
     {
 	CUBE_SCREEN (s);
 
-	if (xid && s->root != xid)
+	if (xid && s->root.id != xid)
 	    continue;
 
 	if (cs->grabIndex)
@@ -1806,7 +1754,7 @@ cubeSetOptionForPlugin (CompObject      *o,
     status = (*core.setOptionForPlugin) (o, plugin, name, value);
     WRAP (cc, &core, setOptionForPlugin, cubeSetOptionForPlugin);
 
-    if (status && o->type == COMP_OBJECT_TYPE_SCREEN)
+    if (status && o->parent && o->type == COMP_OBJECT_TYPE_SCREEN)
     {
 	if (strcmp (plugin, "core") == 0 && strcmp (name, "hsize") == 0)
 	{
@@ -1864,7 +1812,8 @@ cubeInitCore (CompPlugin *p,
 {
     CubeCore *cc;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     cc = malloc (sizeof (CubeCore));
@@ -2081,7 +2030,6 @@ cubeInitScreen (CompPlugin *p,
     WRAP (cs, s, paintScreen, cubePaintScreen);
     WRAP (cs, s, paintOutput, cubePaintOutput);
     WRAP (cs, s, paintTransformedOutput, cubePaintTransformedOutput);
-    WRAP (cs, s, enableOutputClipping, cubeEnableOutputClipping);
     WRAP (cs, s, paintWindow, cubePaintWindow);
     WRAP (cs, s, applyScreenTransform, cubeApplyScreenTransform);
     WRAP (cs, s, outputChangeNotify, cubeOutputChangeNotify);
@@ -2107,7 +2055,6 @@ cubeFiniScreen (CompPlugin *p,
     UNWRAP (cs, s, paintScreen);
     UNWRAP (cs, s, paintOutput);
     UNWRAP (cs, s, paintTransformedOutput);
-    UNWRAP (cs, s, enableOutputClipping);
     UNWRAP (cs, s, paintWindow);
     UNWRAP (cs, s, applyScreenTransform);
     UNWRAP (cs, s, outputChangeNotify);
diff --git a/plugins/dbus.c b/plugins/dbus.c
index bcc6f28..01734d5 100644
--- a/plugins/dbus.c
+++ b/plugins/dbus.c
@@ -65,13 +65,17 @@ typedef struct _DbusCore {
 
     CompFileWatchHandle fileWatch[DBUS_FILE_WATCH_NUM];
 
-    InitPluginForObjectProc initPluginForObject;
-    SetOptionForPluginProc  setOptionForPlugin;
+    SetOptionForPluginProc setOptionForPlugin;
+
+    ObjectAddProc    objectAdd;
+    ObjectRemoveProc objectRemove;
 } DbusCore;
 
 typedef struct _DbusDisplay {
     char         **pluginList;
     unsigned int nPlugins;
+
+    CompTimeoutHandle registerPluginsHandle;
 } DbusDisplay;
 
 static DBusHandlerResult dbusHandleMessage (DBusConnection *,
@@ -96,6 +100,19 @@ static DBusObjectPathVTable dbusMessagesVTable = {
     DbusDisplay *dd = GET_DBUS_DISPLAY (d)
 
 static void
+dbusEmptyPluginList (CompDisplay *d)
+{
+    int i;
+
+    DBUS_DISPLAY (d);
+
+    for (i = 0; i < dd->nPlugins; i++)
+	free (dd->pluginList[i]);
+
+    dd->nPlugins = 0;
+}
+
+static void
 dbusUpdatePluginList (CompDisplay *d)
 {
     CompListValue *pl;
@@ -105,20 +122,15 @@ dbusUpdatePluginList (CompDisplay *d)
 
     pl = &d->opt[COMP_DISPLAY_OPTION_ACTIVE_PLUGINS].value.list;
 
-    for (i = 0; i < dd->nPlugins; i++)
-	free (dd->pluginList[i]);
+    dbusEmptyPluginList (d);
 
     dd->pluginList = realloc (dd->pluginList, pl->nValue * sizeof (char *));
     if (!dd->pluginList)
-    {
-	dd->nPlugins = 0;
 	return;
-    }
 
     for (i = 0; i < pl->nValue; i++)
-	dd->pluginList[i] = strdup (pl->value[i].s);
-
-    dd->nPlugins = pl->nValue;
+	if (findActivePlugin (pl->value[i].s))
+	    dd->pluginList[dd->nPlugins++] = strdup (pl->value[i].s);
 }
 
 static CompOption *
@@ -1814,6 +1826,7 @@ dbusHandleMessage (DBusConnection *connection,
 	dbus_free_string_array (path);
 	return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
     }
+
     /* option message */
     if (dbus_message_is_method_call (message, DBUS_INTERFACE_INTROSPECTABLE,
 				     "Introspect"))
@@ -2169,59 +2182,26 @@ dbusUnregisterPluginsForScreen (DBusConnection *connection,
 }
 
 static CompBool
-dbusInitPluginForDisplay (CompPlugin  *p,
-			  CompDisplay *d)
-{
-    char objectPath[256];
-
-    DBUS_CORE (&core);
-
-    snprintf (objectPath, 256, "%s/%s/%s", COMPIZ_DBUS_ROOT_PATH,
-	      p->vTable->name, "allscreens");
-    dbusRegisterOptions (dc->connection, objectPath);
-
-    return TRUE;
-}
-
-static Bool
-dbusInitPluginForScreen (CompPlugin *p,
-			 CompScreen *s)
+dbusRegisterPlugins (void *data)
 {
-    char objectPath[256];
+    CompDisplay *d = (CompDisplay *) data;
+    CompScreen  *s;
 
     DBUS_CORE (&core);
+    DBUS_DISPLAY (d);
 
-    snprintf (objectPath, 256, "%s/%s/screen%d", COMPIZ_DBUS_ROOT_PATH,
-	      p->vTable->name, s->screenNum);
-    dbusRegisterOptions (dc->connection, objectPath);
-
-    return TRUE;
-}
-
-static CompBool
-dbusInitPluginForObject (CompPlugin *p,
-			 CompObject *o)
-{
-    CompBool status;
-
-    DBUS_CORE (&core);
+    if (d->dirtyPluginList)
+	return TRUE;
 
-    UNWRAP (dc, &core, initPluginForObject);
-    status = (*core.initPluginForObject) (p, o);
-    WRAP (dc, &core, initPluginForObject, dbusInitPluginForObject);
+    dd->registerPluginsHandle = 0;
 
-    if (status && p->vTable->getObjectOptions)
-    {
-	static InitPluginForObjectProc dispTab[] = {
-	    (InitPluginForObjectProc) 0, /* InitPluginForCore */
-	    (InitPluginForObjectProc) dbusInitPluginForDisplay,
-	    (InitPluginForObjectProc) dbusInitPluginForScreen
-	};
+    dbusUpdatePluginList (d);
 
-	RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
-    }
+    dbusRegisterPluginsForDisplay (dc->connection, d);
+    for (s = d->screens; s; s = s->next)
+	dbusRegisterPluginsForScreen (dc->connection, s);
 
-    return status;
+    return FALSE;
 }
 
 static CompBool
@@ -2262,16 +2242,19 @@ dbusSetOptionForPlugin (CompObject      *object,
 		CompScreen *s;
 
 		CORE_DISPLAY (object);
+		DBUS_DISPLAY (d);
 
 		dbusUnregisterPluginsForDisplay (dc->connection, d);
 		for (s = d->screens; s; s = s->next)
 		    dbusUnregisterPluginsForScreen (dc->connection, s);
 
-		dbusUpdatePluginList (d);
+		dbusEmptyPluginList (d);
 
-		dbusRegisterPluginsForDisplay (dc->connection, d);
-		for (s = d->screens; s; s = s->next)
-		    dbusRegisterPluginsForScreen (dc->connection, s);
+		if (!dd->registerPluginsHandle)
+		    dd->registerPluginsHandle =
+			compAddTimeout (10, -1,
+					dbusRegisterPlugins,
+					d);
 	    }
 	}
     }
@@ -2297,6 +2280,84 @@ dbusSendPluginsChangedSignal (const char *name,
     dbus_message_unref (signal);
 }
 
+static void
+dbusDisplayAdd (CompCore    *c,
+		CompDisplay *d)
+{
+    DBUS_DISPLAY (d);
+
+    if (!dd->registerPluginsHandle)
+	dd->registerPluginsHandle = compAddTimeout (10, -1,
+						    dbusRegisterPlugins,
+						    d);
+}
+
+static void
+dbusDisplayRemove (CompCore    *c,
+		   CompDisplay *d)
+{
+    DBUS_CORE (&core);
+
+    dbusUnregisterPluginsForDisplay (dc->connection, d);
+    dbusEmptyPluginList (d);
+}
+
+static void
+dbusScreenAdd (CompDisplay *d,
+	       CompScreen  *s)
+{
+    DBUS_CORE (&core);
+
+    dbusRegisterPluginsForScreen (dc->connection, s);
+}
+
+static void
+dbusScreenRemove (CompDisplay *d,
+		  CompScreen  *s)
+{
+    DBUS_CORE (&core);
+
+    dbusUnregisterPluginsForScreen (dc->connection, s);
+}
+
+static void
+dbusObjectAdd (CompObject *parent,
+	       CompObject *object)
+{
+    static ObjectAddProc dispTab[] = {
+	(ObjectAddProc) 0, /* CoreAdd */
+	(ObjectAddProc) dbusDisplayAdd,
+	(ObjectAddProc) dbusScreenAdd
+    };
+
+    DBUS_CORE (&core);
+
+    UNWRAP (dc, &core, objectAdd);
+    (*core.objectAdd) (parent, object);
+    WRAP (dc, &core, objectAdd, dbusObjectAdd);
+
+    DISPATCH (object, dispTab, ARRAY_SIZE (dispTab), (parent, object));
+}
+
+static void
+dbusObjectRemove (CompObject *parent,
+		  CompObject *object)
+{
+    static ObjectRemoveProc dispTab[] = {
+	(ObjectRemoveProc) 0, /* CoreRemove */
+	(ObjectRemoveProc) dbusDisplayRemove,
+	(ObjectRemoveProc) dbusScreenRemove
+    };
+
+    DBUS_CORE (&core);
+
+    DISPATCH (object, dispTab, ARRAY_SIZE (dispTab), (parent, object));
+
+    UNWRAP (dc, &core, objectRemove);
+    (*core.objectRemove) (parent, object);
+    WRAP (dc, &core, objectRemove, dbusObjectRemove);
+}
+
 static Bool
 dbusInitCore (CompPlugin *p,
 	      CompCore   *c)
@@ -2415,7 +2476,8 @@ dbusInitCore (CompPlugin *p,
 	}
     }
 
-    WRAP (dc, c, initPluginForObject, dbusInitPluginForObject);
+    WRAP (dc, c, objectAdd, dbusObjectAdd);
+    WRAP (dc, c, objectRemove, dbusObjectRemove);
     WRAP (dc, c, setOptionForPlugin, dbusSetOptionForPlugin);
 
     c->base.privates[corePrivateIndex].ptr = dc;
@@ -2452,7 +2514,8 @@ dbusFiniCore (CompPlugin *p,
       dbus_connection_unref (dc->connection);
     */
 
-    UNWRAP (dc, c, initPluginForObject);
+    UNWRAP (dc, c, objectAdd);
+    UNWRAP (dc, c, objectRemove);
     UNWRAP (dc, c, setOptionForPlugin);
 
     free (dc);
@@ -2464,8 +2527,6 @@ dbusInitDisplay (CompPlugin  *p,
 {
     DbusDisplay *dd;
 
-    DBUS_CORE (&core);
-
     dd = malloc (sizeof (DbusDisplay));
     if (!dd)
 	return FALSE;
@@ -2473,10 +2534,12 @@ dbusInitDisplay (CompPlugin  *p,
     dd->pluginList = NULL;
     dd->nPlugins   = 0;
 
+    dd->registerPluginsHandle = 0;
+
     d->base.privates[displayPrivateIndex].ptr = dd;
     
-    dbusUpdatePluginList (d);
-    dbusRegisterPluginsForDisplay (dc->connection, d);
+    if (d->base.parent)
+	dbusObjectAdd (d->base.parent, &d->base);
 
     return TRUE;
 }
@@ -2485,10 +2548,13 @@ static void
 dbusFiniDisplay (CompPlugin  *p,
 		 CompDisplay *d)
 {
-    DBUS_CORE (&core);
     DBUS_DISPLAY (d);
 
-    dbusUnregisterPluginsForDisplay (dc->connection, d);
+    if (dd->registerPluginsHandle)
+	compRemoveTimeout (dd->registerPluginsHandle);
+
+    if (d->base.parent)
+	dbusObjectRemove (d->base.parent, &d->base);
 
     if (dd->pluginList)
     {
@@ -2506,9 +2572,8 @@ static Bool
 dbusInitScreen (CompPlugin *p,
 		CompScreen *s)
 {
-    DBUS_CORE (&core);
-
-    dbusRegisterPluginsForScreen (dc->connection, s);
+    if (s->base.parent)
+	dbusObjectAdd (s->base.parent, &s->base);
 
     return TRUE;
 }
@@ -2517,9 +2582,8 @@ static void
 dbusFiniScreen (CompPlugin *p,
 		CompScreen *s)
 {
-    DBUS_CORE (&core);
-
-    dbusUnregisterPluginsForScreen (dc->connection, s);
+    if (s->base.parent)
+	dbusObjectRemove (s->base.parent, &s->base);
 }
 
 static CompBool
